## reflect-cpp 0.17.0%2Bds

=== tests/json/CMakeLists.txt ===
project(reflect-cpp-json-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-json-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-json-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-json-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-json-tests 
    PRIVATE
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-json-tests)

=== tests/ubjson/CMakeLists.txt ===
project(reflect-cpp-ubjson-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-ubjson-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-ubjson-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_link_libraries(
    reflect-cpp-ubjson-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-ubjson-tests)

=== tests/yaml/CMakeLists.txt ===
project(reflect-cpp-yaml-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-yaml-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-yaml-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-yaml-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-yaml-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-yaml-tests)

## reflect-cpp 0.14.1

=== debian/changelog ===
reflect-cpp (0.14.1-1) unstable; urgency=medium

  * New upstream version 0.14.1 (closes: #1085435)

 -- Shengqi Chen <harry-chen@outlook.com>  Mon, 21 Oct 2024 16:31:36 +0800

=== debian/control ===
Source: reflect-cpp
Section: utils
Priority: optional
Standards-Version: 4.7.0
Maintainer: Shengqi Chen <harry-chen@outlook.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 libgtest-dev,
 libflatbuffers-dev,
 libmsgpack-c-dev,
 libpugixml-dev,
 libtomlplusplus-dev,
 libyaml-cpp-dev,
 libyyjson-dev
Homepage: https://getml.github.io/reflect-cpp/
Vcs-Git: https://salsa.debian.org/harry/reflect-cpp.git
Vcs-Browser: https://salsa.debian.org/harry/reflect-cpp
Rules-Requires-Root: no

Package: libreflectcpp0.14
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 library for fast (de-)serialization and validation (shared library)
 reflect-cpp is a C++20 library for fast serialization, deserialization
 and validation using reflection. It supports JSON, BSON, CBOR,
 flexbuffers, msgpack, TOML, XML, YAML / msgpack.org.
 .
 This package contains libreflectcpp shared library.

Package: libreflectcpp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libreflectcpp0.14 (= ${binary:Version})
Suggests:
 libflatbuffers-dev,
 libmsgpack-c-dev,
 libpugixml-dev,
 libtomlplusplus-dev,
 libyaml-cpp-dev,
 libyyjson-dev
Description: C++20 library for fast (de-)serialization and validation (development files)
 reflect-cpp is a C++20 library for fast serialization, deserialization
 and validation using reflection. It supports JSON, BSON, CBOR,
 flexbuffers, msgpack, TOML, XML, YAML / msgpack.org.
 .
 This package contains development files for libreflectcpp.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

ifeq (,$(filter, nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_TEST = ON
else
BUILD_TEST = OFF
endif

%:
	dh $@ --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- -DREFLECTCPP_BUILD_SHARED=ON -DREFLECTCPP_USE_BUNDLED_DEPENDENCIES=OFF \
	 -DREFLECTCPP_USE_VCPKG=OFF -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) \
	 -DREFLECTCPP_FLEXBUFFERS=ON -DREFLECTCPP_MSGPACK=ON -DREFLECTCPP_XML=ON \
	 -DREFLECTCPP_TOML=ON -DREFLECTCPP_YAML=ON \
	 -DREFLECTCPP_BUILD_TESTS=$(BUILD_TEST)

override_dh_installdocs:
	sed -i 's|https://github.com/getml/reflect-cpp/blob/main/docs/||g' docs/README.md
	dh_installdocs

=== debian/watch ===
version=4
https://github.com/getml/reflect-cpp/tags .*/v?(\d.*)@ARCHIVE_EXT@

## reflect-cpp 0.17.0

=== debian/changelog ===
reflect-cpp (0.17.0-5) unstable; urgency=medium

  * d/rules: fix wrongly inverted build condition for bson

 -- Shengqi Chen <harry@debian.org>  Thu, 27 Feb 2025 00:13:05 +0800

reflect-cpp (0.17.0-4) unstable; urgency=medium

  * d/tests: set DEB_*_ARCH env before running autopkgtest
  * d/control: bump std-ver to 4.7.1 (no changes required)

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 15:53:50 +0800

reflect-cpp (0.17.0-3) unstable; urgency=medium

  * d/{rules,control}: fix wrong dependency conditions

 -- Shengqi Chen <harry@debian.org>  Sat, 22 Feb 2025 18:57:08 +0800

reflect-cpp (0.17.0-2) unstable; urgency=medium

  * Conditionally enable formats to fix FTBFS:
    + disable capnproto on m68k, s390x, powerpc, ppc64, sparc64, hppa,
      hurd-i386.
    + disable bson on hurd-amd64.

 -- Shengqi Chen <harry@debian.org>  Thu, 20 Feb 2025 16:14:38 +0800

reflect-cpp (0.17.0-1) unstable; urgency=medium

  * d/control: mark Multi-Arch: same for libreflectcpp
  * d/rules: disable compiling tests on sh4 to fix ftbfs
  * Enable more formats: avro, bson, capnproto

 -- Shengqi Chen <harry@debian.org>  Fri, 14 Feb 2025 00:52:01 +0800

reflect-cpp (0.17.0-1~exp1) experimental; urgency=medium

  * New upstream version 0.17.0
    + Change SONAME to libreflectcpp0.17
  * d/patches: remove applied patches
  * d/patches: add patch to fix cmake dependencies
  * d/rules: remove workaround that is no longer valid
  * d/control: use my d.o email address

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Feb 2025 16:45:23 +0800

=== debian/control ===
Source: reflect-cpp
Section: utils
Priority: optional
Standards-Version: 4.7.1
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 libgtest-dev,
 libavro-dev,
 libbson-dev [!hurd-amd64],
 libcapnp-dev [!m68k !s390x !powerpc !ppc64 !hppa !sparc64 !hurd-i386 !hurd-amd64],
 libflatbuffers-dev,
 libmsgpack-c-dev,
 libpugixml-dev,
 libtomlplusplus-dev,
 libyaml-cpp-dev,
 libyyjson-dev,
 pkgconf,
Homepage: https://getml.github.io/reflect-cpp/
Vcs-Git: https://salsa.debian.org/harry/reflect-cpp.git
Vcs-Browser: https://salsa.debian.org/harry/reflect-cpp
Rules-Requires-Root: no

Package: libreflectcpp0.17
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 library for fast (de-)serialization and validation (shared library)
 reflect-cpp is a C++20 library for fast serialization, deserialization
 and validation using reflection. It supports JSON, BSON, CBOR,
 flexbuffers, msgpack, TOML, XML, YAML / msgpack.org.
 .
 This package contains libreflectcpp shared library.

Package: libreflectcpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libreflectcpp0.17 (= ${binary:Version})
Suggests:
 libavro-dev,
 libbson-dev,
 libcapnp-dev,
 libflatbuffers-dev,
 libmsgpack-c-dev,
 libpugixml-dev,
 libtomlplusplus-dev,
 libyaml-cpp-dev,
 libyyjson-dev,
Description: C++20 library for fast (de-)serialization and validation (development files)
 reflect-cpp is a C++20 library for fast serialization, deserialization
 and validation using reflection. It supports JSON, BSON, CBOR,
 flexbuffers, msgpack, TOML, XML, YAML / msgpack.org.
 .
 This package contains development files for libreflectcpp.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

BUILD_TEST = OFF
ifeq (,$(filter, nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(DEB_HOST_ARCH),sh4) # fails to compile some tests (OOM?)
BUILD_TEST = ON
endif
endif

USE_CAPNPROTO = ON
# no or too old libcapnp on m68k, hppa, hurd
# fail unit tests on big endian arch: s390x, powerpc, ppc64, sparc64
ifneq (,$(filter $(DEB_HOST_ARCH), m68k s390x powerpc ppc64 sparc64 hppa hurd-i386 hurd-amd64))
USE_CAPNPROTO = OFF
endif

USE_BSON=ON
# no libbson exists
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-amd64))
USE_BSON=OFF
endif

%:
	dh $@ --buildsystem=cmake+ninja

# cbor / ubjson requires jsoncons, currently not in debian
override_dh_auto_configure:
	dh_auto_configure -- -DREFLECTCPP_BUILD_SHARED=ON -DREFLECTCPP_USE_BUNDLED_DEPENDENCIES=OFF \
	 -DREFLECTCPP_USE_VCPKG=OFF -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) \
	 -DREFLECTCPP_JSON=ON -DREFLECTCPP_AVRO=ON -DREFLECTCPP_BSON=$(USE_BSON) \
	 -DREFLECTCPP_CAPNPROTO=$(USE_CAPNPROTO) -DREFLECTCPP_CBOR=OFF \
	 -DREFLECTCPP_FLEXBUFFERS=ON -DREFLECTCPP_MSGPACK=ON -DREFLECTCPP_XML=ON \
	 -DREFLECTCPP_TOML=ON -DREFLECTCPP_UBJSON=OFF -DREFLECTCPP_YAML=ON \
	 -DREFLECTCPP_BUILD_TESTS=$(BUILD_TEST)

## reflect-cpp 0.17.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,9 @@
  ninja-build,
  libgtest-dev,
  libavro-dev,
- libbson-dev [!hurd-amd64],
+ libbson-dev [!hurd-i386 !hurd-amd64],
  libcapnp-dev [!m68k !s390x !powerpc !ppc64 !hppa !sparc64 !hurd-i386 !hurd-amd64],
+ libctre-dev,
  libflatbuffers-dev,
  libmsgpack-c-dev,
  libpugixml-dev,

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 USE_BSON=ON
 # no libbson exists
-ifneq (,$(filter $(DEB_HOST_ARCH), hurd-amd64))
+ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
 USE_BSON=OFF
 endif

## reflect-cpp 0.17.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.23)

option(REFLECTCPP_BUILD_SHARED "Build shared library" ${BUILD_SHARED_LIBS})

option(REFLECTCPP_JSON "Enable JSON support" ON) # enabled by default
option(REFLECTCPP_AVRO "Enable AVRO support" OFF)
option(REFLECTCPP_BSON "Enable BSON support" OFF)
option(REFLECTCPP_CAPNPROTO "Enable Cap’n Proto support" OFF)
option(REFLECTCPP_CBOR "Enable CBOR support" OFF)
option(REFLECTCPP_FLEXBUFFERS "Enable flexbuffers support" OFF)
option(REFLECTCPP_MSGPACK "Enable msgpack support" OFF)
option(REFLECTCPP_XML "Enable XML support" OFF)
option(REFLECTCPP_TOML "Enable TOML support" OFF)
option(REFLECTCPP_UBJSON "Enable UBJSON support" OFF)
option(REFLECTCPP_YAML "Enable YAML support" OFF)

option(REFLECTCPP_BUILD_BENCHMARKS "Build benchmarks" OFF)
option(REFLECTCPP_BUILD_TESTS "Build tests" OFF)

option(REFLECTCPP_USE_BUNDLED_DEPENDENCIES "Use the bundled dependencies" ON)

set(REFLECTCPP_USE_VCPKG_DEFAULT OFF)

if(REFLECTCPP_BUILD_BENCHMARKS)
    set(REFLECTCPP_JSON ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_AVRO ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_BSON ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_CAPNPROTO ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_CBOR ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_FLEXBUFFERS ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_MSGPACK ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_XML ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_TOML ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_UBJSON ON CACHE BOOL "" FORCE)
    set(REFLECTCPP_YAML ON CACHE BOOL "" FORCE)
endif()

if (REFLECTCPP_BUILD_TESTS OR REFLECTCPP_BUILD_BENCHMARKS OR
    (REFLECTCPP_JSON AND NOT REFLECTCPP_USE_BUNDLED_DEPENDENCIES) OR REFLECTCPP_AVRO OR
    REFLECTCPP_BSON OR REFLECTCPP_CAPNPROTO OR REFLECTCPP_CBOR OR REFLECTCPP_FLEXBUFFERS OR 
    REFLECTCPP_MSGPACK OR REFLECTCPP_XML OR REFLECTCPP_TOML OR REFLECTCPP_UBJSON OR REFLECTCPP_YAML)
    # enable vcpkg per default if features other than JSON are required
    set(REFLECTCPP_USE_VCPKG_DEFAULT ON)
endif()

option(REFLECTCPP_USE_VCPKG "Use VCPKG to download and build dependencies" ${REFLECTCPP_USE_VCPKG_DEFAULT})

if (REFLECTCPP_USE_VCPKG)
    set(CMAKE_TOOLCHAIN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/vcpkg/scripts/buildsystems/vcpkg.cmake CACHE STRING "Vcpkg toolchain file")
endif ()

project(reflectcpp VERSION 0.17.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)

if (REFLECTCPP_BUILD_SHARED)
    add_library(reflectcpp SHARED)
    set_target_properties(reflectcpp PROPERTIES SOVERSION ${PROJECT_VERSION})
else()
    add_library(reflectcpp STATIC)
endif()

if (MSVC)
    target_compile_options(reflectcpp PRIVATE $<$<CONFIG:Debug>:-Wall>)
else()
    target_compile_options(reflectcpp PRIVATE $<$<CONFIG:Debug>:-Wall -Wextra>)
endif()

set(REFLECT_CPP_SOURCES
    src/reflectcpp.cpp
)

target_include_directories(
    reflectcpp PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

if (REFLECTCPP_USE_BUNDLED_DEPENDENCIES)
    target_include_directories(
        reflectcpp PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/rfl/thirdparty>)
else ()
    if (NOT TARGET ctre::ctre)
        find_package(ctre CONFIG REQUIRED)
    endif ()
    target_link_libraries(reflectcpp PUBLIC ctre::ctre)
endif ()

if (REFLECTCPP_JSON)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_json.cpp
    )
    if (REFLECTCPP_USE_BUNDLED_DEPENDENCIES)
        list(APPEND REFLECT_CPP_SOURCES
            src/yyjson.c
        )
        set_source_files_properties(src/yyjson.c PROPERTIES LANGUAGE CXX)

        target_include_directories(
            reflectcpp PUBLIC
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/rfl/thirdparty>)
    else ()
        if (NOT TARGET yyjson::yyjson)
            find_package(yyjson CONFIG REQUIRED)
        endif ()
        target_link_libraries(reflectcpp PUBLIC yyjson::yyjson)
    endif ()
endif ()

if (REFLECTCPP_AVRO)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_avro.cpp
    )
    find_package(jansson CONFIG REQUIRED)
    if(REFLECTCPP_USE_VCPKG)
        target_include_directories(reflectcpp SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")
        if (MSVC)
            target_link_libraries(reflectcpp PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib/avro${CMAKE_STATIC_LIBRARY_SUFFIX}")
        else ()
            target_link_libraries(reflectcpp PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib/libavro${CMAKE_STATIC_LIBRARY_SUFFIX}")
        endif ()
    endif()
    target_link_libraries(reflectcpp PRIVATE jansson::jansson)
endif ()

if (REFLECTCPP_BSON)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_bson.cpp
    )
    if (NOT TARGET mongo::bson_static AND NOT TARGET mongo::bson_shared)
        find_package(bson-1.0 CONFIG REQUIRED)
    endif ()
    target_link_libraries(reflectcpp PUBLIC $<IF:$<TARGET_EXISTS:mongo::bson_static>,mongo::bson_static,mongo::bson_shared>)
endif ()

if (REFLECTCPP_CAPNPROTO)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_capnproto.cpp
    )
    if (NOT TARGET CapnProto)
        find_package(CapnProto CONFIG REQUIRED)
    endif ()
     target_link_libraries(reflectcpp PUBLIC CapnProto::kj CapnProto::capnp CapnProto::capnpc CapnProto::kj-gzip)
endif ()

if (REFLECTCPP_CBOR)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_cbor.cpp
    )
    if (NOT TARGET jsoncons)
      find_package(jsoncons CONFIG REQUIRED)
    endif()
    include_directories(PUBLIC ${jsoncons_INCLUDE_DIRS})
endif ()

if (REFLECTCPP_FLEXBUFFERS)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_flexbuf.cpp
    )
    if (NOT TARGET flatbuffers::flatbuffers)
        find_package(flatbuffers CONFIG REQUIRED)
    endif ()
    target_link_libraries(reflectcpp PUBLIC flatbuffers::flatbuffers)
endif ()

if (REFLECTCPP_MSGPACK)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_msgpack.cpp
    )
    if(REFLECTCPP_USE_VCPKG)
        if (NOT TARGET msgpack-c)
            find_package(msgpack-c CONFIG REQUIRED)
        endif()
    else()
        if (NOT TARGET msgpack)
          find_package(msgpack CONFIG REQUIRED)
        endif()
    endif()
    target_link_libraries(reflectcpp PUBLIC msgpack-c)
endif ()

if (REFLECTCPP_TOML)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_toml.cpp
    )
    if(REFLECTCPP_USE_VCPKG)
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(tomlplusplus REQUIRED IMPORTED_TARGET tomlplusplus)
        target_link_libraries(reflectcpp PUBLIC PkgConfig::tomlplusplus)
    else()
        if (NOT TARGET tomlplusplus)
          find_package(tomlplusplus)
        endif()
        target_link_libraries(reflectcpp PUBLIC tomlplusplus::tomlplusplus)
    endif()
endif()

if (REFLECTCPP_UBJSON)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_ubjson.cpp
    )
    if (NOT TARGET jsoncons)
      find_package(jsoncons CONFIG REQUIRED)
    endif()
    include_directories(PUBLIC ${jsoncons_INCLUDE_DIRS})
endif ()

if (REFLECTCPP_XML)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_xml.cpp
    )
    if (NOT TARGET pugixml::pugixml)
        find_package(pugixml CONFIG REQUIRED)
    endif ()
    target_link_libraries(reflectcpp PUBLIC pugixml::pugixml)
endif ()

if (REFLECTCPP_YAML)
    list(APPEND REFLECT_CPP_SOURCES
        src/reflectcpp_yaml.cpp
    )
    if (NOT TARGET yaml-cpp::yaml-cpp)
        find_package(yaml-cpp CONFIG REQUIRED)
    endif ()
    target_link_libraries(reflectcpp PUBLIC yaml-cpp::yaml-cpp)
endif ()

set_target_properties(reflectcpp PROPERTIES LINKER_LANGUAGE CXX)
target_sources(reflectcpp PRIVATE ${REFLECT_CPP_SOURCES})
target_precompile_headers(reflectcpp PRIVATE [["rfl.hpp"]] <iostream> <string> <functional>)

if (REFLECTCPP_BUILD_TESTS)
    enable_testing()
    find_package(GTest CONFIG REQUIRED)
    set(REFLECT_CPP_GTEST_LIB reflectcpp GTest::gtest_main)
    add_subdirectory(tests)
endif ()

if (REFLECTCPP_BUILD_BENCHMARKS)
    if (NOT TARGET benchmark::benchmark)
        find_package(benchmark CONFIG REQUIRED)
    endif ()
    if (NOT TARGET simdjson::simdjson)
        find_package(simdjson CONFIG REQUIRED)
    endif ()
    target_link_libraries(reflectcpp PUBLIC benchmark::benchmark simdjson::simdjson)
    add_subdirectory(benchmarks)
endif ()

if (PROJECT_IS_TOP_LEVEL)
    include(GNUInstallDirs)
    include(CMakePackageConfigHelpers)

    configure_package_config_file(reflectcpp-config.cmake.in
      ${CMAKE_CURRENT_BINARY_DIR}/reflectcpp-config.cmake
      INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/reflectcpp
      )

    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/reflectcpp-config.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/reflectcpp"
    )

    file(GLOB_RECURSE RFL_HEADERS RELATIVE ${CMAKE_CURRENT_LIST_DIR} "${CMAKE_CURRENT_LIST_DIR}/include/*" )

    target_sources(reflectcpp
        PUBLIC
        FILE_SET reflectcpp_headers
        TYPE HEADERS
        BASE_DIRS $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
        FILES ${RFL_HEADERS})

    install(
        TARGETS reflectcpp
        EXPORT reflectcpp-exports
        FILE_SET reflectcpp_headers DESTINATION ${INCLUDE_INSTALL_DIR}
        )

    install(
        EXPORT reflectcpp-exports
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/reflectcpp
        NAMESPACE reflectcpp::
    )
endif ()

=== tests/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2")

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std:c++20")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wall -ggdb -ftemplate-backtrace-limit=0")
endif()

if (REFLECTCPP_JSON)
    add_subdirectory(generic)
    add_subdirectory(json)
    add_subdirectory(json_c_arrays_and_inheritance)
endif ()

if (REFLECTCPP_AVRO)
    add_subdirectory(avro)
endif()

if (REFLECTCPP_BSON)
    add_subdirectory(bson)
endif()

if (REFLECTCPP_CAPNPROTO)
    add_subdirectory(capnproto)
endif()

if (REFLECTCPP_CBOR)
    add_subdirectory(cbor)
endif()

if (REFLECTCPP_FLEXBUFFERS)
    add_subdirectory(flexbuffers)
endif()

if (REFLECTCPP_MSGPACK)
    add_subdirectory(msgpack)
endif()

if (REFLECTCPP_TOML)
    add_subdirectory(toml)
endif()

if (REFLECTCPP_UBJSON)
    add_subdirectory(ubjson)
endif()

if (REFLECTCPP_XML)
    add_subdirectory(xml)
endif()

if (REFLECTCPP_YAML)
    add_subdirectory(yaml)
endif()

=== benchmarks/all/CMakeLists.txt ===
project(reflect-cpp-all-format-benchmarks)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-all-format-benchmarks 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-all-format-benchmarks PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-all-format-benchmarks SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")
target_include_directories(reflect-cpp-all-format-benchmarks SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include/tinycbor")

target_link_libraries(
    reflect-cpp-all-format-benchmarks
    PRIVATE 
    reflectcpp
)

=== tests/cbor/CMakeLists.txt ===
project(reflect-cpp-cbor-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-cbor-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-cbor-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_link_libraries(
    reflect-cpp-cbor-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-cbor-tests)

=== tests/flexbuffers/CMakeLists.txt ===
project(reflect-cpp-flexbuffers-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-flexbuffers-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-flexbuffers-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-flexbuffers-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-flexbuffers-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-flexbuffers-tests)

=== tests/generic/CMakeLists.txt ===
project(reflect-cpp-generic-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-generic-tests 
    ${SOURCES}
)

target_include_directories(reflect-cpp-generic-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-generic-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-generic-tests)

=== tests/json_c_arrays_and_inheritance/CMakeLists.txt ===
project(reflect-cpp-json-c-arrays-and-inheritance-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-json-c-arrays-and-inheritance-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-json-c-arrays-and-inheritance-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)


SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DREFLECT_CPP_C_ARRAYS_OR_INHERITANCE")

target_include_directories(reflect-cpp-json-c-arrays-and-inheritance-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-json-c-arrays-and-inheritance-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-json-c-arrays-and-inheritance-tests)

=== tests/msgpack/CMakeLists.txt ===
project(reflect-cpp-msgpack-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-msgpack-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-msgpack-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-msgpack-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-msgpack-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-msgpack-tests)

=== tests/toml/CMakeLists.txt ===
project(reflect-cpp-toml-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-toml-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-toml-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_link_libraries(
    reflect-cpp-toml-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-toml-tests)

=== tests/xml/CMakeLists.txt ===
project(reflect-cpp-xml-tests)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-xml-tests 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-xml-tests PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-xml-tests SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-xml-tests 
    PRIVATE 
    "${REFLECT_CPP_GTEST_LIB}"
)

find_package(GTest)
gtest_discover_tests(reflect-cpp-xml-tests)

=== debian/changelog ===
reflect-cpp (0.17.0+ds-1) unstable; urgency=medium

  * d/control: remove vendored files from upstream tarball
  * Disable bson support on hurd-i386
  * d/watch: enable repacking and name mangling
  * New upstream version 0.17.0+ds

 -- Shengqi Chen <harry@debian.org>  Tue, 11 Mar 2025 20:50:28 +0800

=== debian/watch ===
version=4
 opts="repack,dversionmangle=auto,repacksuffix=+ds" \
 https://github.com/getml/reflect-cpp/tags .*/v?(\d.*)@ARCHIVE_EXT@

## reflect-cpp 0.18.0%2Bds

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 if (MSVC)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std:c++20")
 else()
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wall -ggdb -ftemplate-backtrace-limit=0")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wall -Werror -ggdb -ftemplate-backtrace-limit=0")
 endif()
 
 if (REFLECTCPP_JSON)

## reflect-cpp 0.18.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,21 @@
 option(REFLECTCPP_BUILD_TESTS "Build tests" OFF)
 
 option(REFLECTCPP_USE_BUNDLED_DEPENDENCIES "Use the bundled dependencies" ON)
+
+option(REFLECTCPP_USE_STD_EXPECTED "Use std::expected instead of the built-in Result type (requires C++-23)" OFF)
+
+if(REFLECTCPP_USE_STD_EXPECTED)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DREFLECTCPP_USE_STD_EXPECTED")
+    if(NOT DEFINED CMAKE_CXX_STANDARD)
+        set(CMAKE_CXX_STANDARD 23)
+    endif()
+else()
+    if(NOT DEFINED CMAKE_CXX_STANDARD)
+        set(CMAKE_CXX_STANDARD 20)
+    endif()
+endif()
+
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 set(REFLECTCPP_USE_VCPKG_DEFAULT OFF)
 
@@ -51,8 +66,6 @@
 
 project(reflectcpp VERSION 0.17.0 LANGUAGES CXX)
 
-set(CMAKE_CXX_STANDARD 20)
-
 if (REFLECTCPP_BUILD_SHARED)
     add_library(reflectcpp SHARED)
     set_target_properties(reflectcpp PROPERTIES SOVERSION ${PROJECT_VERSION})
@@ -112,14 +125,18 @@
         src/reflectcpp_avro.cpp
     )
     find_package(jansson CONFIG REQUIRED)
-    if(REFLECTCPP_USE_VCPKG)
+    if (REFLECTCPP_USE_VCPKG)
         target_include_directories(reflectcpp SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")
         if (MSVC)
             target_link_libraries(reflectcpp PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib/avro${CMAKE_STATIC_LIBRARY_SUFFIX}")
         else ()
             target_link_libraries(reflectcpp PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib/libavro${CMAKE_STATIC_LIBRARY_SUFFIX}")
         endif ()
-    endif()
+    else ()
+        find_package(PkgConfig REQUIRED)
+        pkg_check_modules(avro REQUIRED IMPORTED_TARGET avro-c)
+        target_link_libraries(reflectcpp PUBLIC PkgConfig::avro)
+    endif ()
     target_link_libraries(reflectcpp PRIVATE jansson::jansson)
 endif ()
 
@@ -167,14 +184,8 @@
     list(APPEND REFLECT_CPP_SOURCES
         src/reflectcpp_msgpack.cpp
     )
-    if(REFLECTCPP_USE_VCPKG)
-        if (NOT TARGET msgpack-c)
-            find_package(msgpack-c CONFIG REQUIRED)
-        endif()
-    else()
-        if (NOT TARGET msgpack)
-          find_package(msgpack CONFIG REQUIRED)
-        endif()
+    if (NOT TARGET msgpack-c)
+        find_package(msgpack-c CONFIG REQUIRED NAMES msgpack msgpack-c)
     endif()
     target_link_libraries(reflectcpp PUBLIC msgpack-c)
 endif ()
@@ -183,16 +194,10 @@
     list(APPEND REFLECT_CPP_SOURCES
         src/reflectcpp_toml.cpp
     )
-    if(REFLECTCPP_USE_VCPKG)
-        find_package(PkgConfig REQUIRED)
-        pkg_check_modules(tomlplusplus REQUIRED IMPORTED_TARGET tomlplusplus)
-        target_link_libraries(reflectcpp PUBLIC PkgConfig::tomlplusplus)
-    else()
-        if (NOT TARGET tomlplusplus)
-          find_package(tomlplusplus)
-        endif()
-        target_link_libraries(reflectcpp PUBLIC tomlplusplus::tomlplusplus)
-    endif()
+    if (NOT TARGET toml11)
+      find_package(toml11 CONFIG REQUIRED)
+    endif()
+    target_link_libraries(reflectcpp PUBLIC toml11::toml11)
 endif()
 
 if (REFLECTCPP_UBJSON)

=== benchmarks/json/CMakeLists.txt ===
project(reflect-cpp-json-benchmarks)

file(GLOB_RECURSE SOURCES CONFIGURE_DEPENDS "*.cpp")

add_executable(
    reflect-cpp-json-benchmarks 
    ${SOURCES}
)
target_precompile_headers(reflect-cpp-json-benchmarks PRIVATE [["rfl.hpp"]] <iostream> <string> <functional> <gtest/gtest.h>)

target_include_directories(reflect-cpp-json-benchmarks SYSTEM PRIVATE "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/include")

target_link_libraries(
    reflect-cpp-json-benchmarks
    PRIVATE 
    reflectcpp
)

=== tests/json/CMakeLists.txt ===
--- 
+++ 
@@ -18,3 +18,4 @@
 
 find_package(GTest)
 gtest_discover_tests(reflect-cpp-json-tests)
+

=== debian/changelog ===
reflect-cpp (0.18.0+ds-3) unstable; urgency=medium

  * d/{control,rules}: add B-D on libjsoncons-dev to support CBOR and UBJSON.

 -- Shengqi Chen <harry@debian.org>  Fri, 25 Apr 2025 15:16:15 +0800

reflect-cpp (0.18.0+ds-2) unstable; urgency=medium

  * d/rules: pass -Wno-error=array-bounds to fix FTBFS (closes: #1102676).

 -- Shengqi Chen <harry@debian.org>  Sat, 12 Apr 2025 21:45:02 +0800

reflect-cpp (0.18.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Fri, 11 Apr 2025 14:33:43 +0800

reflect-cpp (0.18.0+ds-1~exp1) experimental; urgency=medium

  * New upstream version 0.18.0+ds.
    + Change SONAME to libreflectcpp0.18.
  * d/control:
    + replace libtomlplusplus-dev with libtoml11-dev according to upstream.
    + bump std-ver to 4.7.2 (no changes required).
  * d/patches:
    + refresh existing patches.
    + update patch to remove hardcoded SOVERSION and set a correct version.
  * d/copyright: remove superfluous patterns and update years

 -- Shengqi Chen <harry@debian.org>  Tue, 08 Apr 2025 00:52:06 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: reflect-cpp
 Section: utils
 Priority: optional
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -13,9 +13,10 @@
  libcapnp-dev [!m68k !s390x !powerpc !ppc64 !hppa !sparc64 !hurd-i386 !hurd-amd64],
  libctre-dev,
  libflatbuffers-dev,
+ libjsoncons-dev,
  libmsgpack-c-dev,
  libpugixml-dev,
- libtomlplusplus-dev,
+ libtoml11-dev,
  libyaml-cpp-dev,
  libyyjson-dev,
  pkgconf,
@@ -24,7 +25,7 @@
 Vcs-Browser: https://salsa.debian.org/harry/reflect-cpp
 Rules-Requires-Root: no
 
-Package: libreflectcpp0.17
+Package: libreflectcpp0.18
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -40,15 +41,16 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libreflectcpp0.17 (= ${binary:Version})
+Depends: ${misc:Depends}, libreflectcpp0.18 (= ${binary:Version})
 Suggests:
  libavro-dev,
  libbson-dev,
  libcapnp-dev,
  libflatbuffers-dev,
+ libjsoncons-dev,
  libmsgpack-c-dev,
  libpugixml-dev,
- libtomlplusplus-dev,
+ libtoml11-dev,
  libyaml-cpp-dev,
  libyyjson-dev,
 Description: C++20 library for fast (de-)serialization and validation (development files)

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+# gcc has strange false positives on array bounds (some arches)
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=array-bounds
 DPKG_EXPORT_BUILDFLAGS = 1
 
 include /usr/share/dpkg/buildflags.mk
@@ -31,13 +33,12 @@
 %:
 	dh $@ --buildsystem=cmake+ninja
 
-# cbor / ubjson requires jsoncons, currently not in debian
 override_dh_auto_configure:
 	dh_auto_configure -- -DREFLECTCPP_BUILD_SHARED=ON -DREFLECTCPP_USE_BUNDLED_DEPENDENCIES=OFF \
 	 -DREFLECTCPP_USE_VCPKG=OFF -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) \
 	 -DREFLECTCPP_JSON=ON -DREFLECTCPP_AVRO=ON -DREFLECTCPP_BSON=$(USE_BSON) \
-	 -DREFLECTCPP_CAPNPROTO=$(USE_CAPNPROTO) -DREFLECTCPP_CBOR=OFF \
+	 -DREFLECTCPP_CAPNPROTO=$(USE_CAPNPROTO) -DREFLECTCPP_CBOR=ON \
 	 -DREFLECTCPP_FLEXBUFFERS=ON -DREFLECTCPP_MSGPACK=ON -DREFLECTCPP_XML=ON \
-	 -DREFLECTCPP_TOML=ON -DREFLECTCPP_UBJSON=OFF -DREFLECTCPP_YAML=ON \
+	 -DREFLECTCPP_TOML=ON -DREFLECTCPP_UBJSON=ON -DREFLECTCPP_YAML=ON \
 	 -DREFLECTCPP_BUILD_TESTS=$(BUILD_TEST)

## reflect-cpp 0.21.0%2Bds

=== tests/cbor/CMakeLists.txt ===
--- 
+++ 
@@ -16,3 +16,4 @@
 
 find_package(GTest)
 gtest_discover_tests(reflect-cpp-cbor-tests)
+
